#include "sentence.h"

FUN FormulaPtr CalCall( s )
SentencePtr s; 
{
	ProcedurePtr proc;
	AssignListPtr iop, inp, e1, e2, e3;
	FormulaPtr prepost, p, post, r, q;
	FormulaListPtr eList, rList, postList, pList;

	proc = Procedure2Ptr( s->labels1 ); 
	if (proc==NULL) { Error( "Procedure Call" ); return( NULL ); }

	iop = AssignListSelect( s->assignList, proc, isIop );
	inp = AssignListSelect( s->assignList, proc, isInp );


        prepost = CombineCond( FormulaCopy( proc->preCond ),
                                LAND,
                                FormulaCopy( proc->postCond ));
        prepost = EgenVarRename2( prepost );

        p = prepost->left;
	post = EgenVarRename( prepost->right );

        p = FormulaSubstSim( p, s->assignList );

	postList = Formula2FormulaList( post, LAND );

	eList = FormulaListSelect( postList, proc, isAssign );
	rList = FormulaListSelect( postList, proc, isNotAssign );

	eList = FormulaListRewrite( eList );

	e1 = FormulaList2AssignList( eList );
        rList = FormulaListSubstSim( rList, e1 );
        rList = FormulaListSubstSim( rList, s->assignList );

        eList = FormulaListSubstSim( eList, s->assignList );
	e2 = FormulaList2AssignList( eList );
        q = FormulaSubstSim( FormulaCopy( s->postCond ), e2 );
	
        if (rList!=NULL) {
                r = FormulaList2Formula( rList, LAND );
                q = CombineCond( CombineCond( NULL, '~', r ), '|', q );
        }

	pList = Formula2FormulaList( p, LAND );
	e3 = FormulaList2AssignList( FormulaListSelect( pList, proc, isInit ));
	pList = FormulaListSelect( pList, proc, isNotInit );
	p = FormulaList2Formula( pList, LAND );

        q = FormulaSubstSim( q, e3 );
        p = FormulaSubstSim( p, e3 );
 
        if (p!=NULL)  q = CombineCond( p, '^', q );
	s->preCond = q;

	CleanPtrList( e1 );
	CleanPtrList( e2 );
	CleanPtrList( inp );
	CleanPtrList( iop );
	CleanPtrList( rList );
	CleanPtrList( eList );
	CleanPtrList( postList );
	CleanPtrList( pList );
	return( q );
}

/*------------------------------------------------------------*/

FUN int isIop( t, proc )
TermPtr t; ProcedurePtr proc;
{
	ParamTrippleListPtr p = proc->params;

	while (p!=NULL) {
		if (strcmp( t->name, p->name )==0) {
			if (strcmp( p->io, "%IOP" )==0) return( 1 );
		}
		p = p->paramTrippleList;
	}
}

FUN int isInp( t, proc )
TermPtr t; ProcedurePtr proc;
{
	ParamTrippleListPtr p = proc->params;

	while (p!=NULL) {
		if (strcmp( t->name, p->name )==0) {
			if (strcmp( p->io, "%INP" )==0) return( 1 );
		}
		p = p->paramTrippleList;
	}
}

FUN AssignListPtr AssignListSelect( p, proc, f )
AssignListPtr p; ProcedurePtr proc; int (*f)();
{
        AssignListPtr c = p;
        AssignListPtr c1, c2, c3;
        int first = 1;
 
        c3 = c2 = c1 = 
                (AssignListPtr) calloc( sizeof( AssignList ), 1 );
        while (c != NULL ) {  
                if (f( c->assign->termLeft, proc)) {
                        c1->assign = c->assign;
                        c1->assignList = (AssignListPtr)
                                calloc( sizeof( AssignList ), 1 );
                        c2 = c1;
                        c1 = c1->assignList;
                }
                c = c->assignList;
        }
        if (c2->assignList != NULL) {
                free( c2->assignList );
                c2->assignList = NULL;
        } else {
                free( c3 );
                c3 = NULL;
        }
        return( c3 );
}
 
/*------------------------------------------------------------*/

 
FUN FormulaListPtr FormulaListSelect( p, proc, f )
FormulaListPtr p; ProcedurePtr proc; int (*f)();
{
        FormulaListPtr c = p;
        FormulaListPtr c1, c2, c3;
        int first = 1;

        c3 = c2 = c1 =
                (FormulaListPtr) calloc( sizeof( FormulaList ), 1 );
        while (c != NULL ) {
                if (f( c->formula, proc)) {
                        c1->formula = c->formula;
                        c1->formulaList = (FormulaListPtr)
                                calloc( sizeof( FormulaList ), 1 );
                        c2 = c1;
                        c1 = c1->formulaList;
                }
                c = c->formulaList;
        }
        if (c2->formulaList != NULL) {
                free( c2->formulaList );
                c2->formulaList = NULL;
        } else {
                free( c3 );
                c3 = NULL;
        }
        return( c3 );
}
 
FUN int isAssign( p, proc )
FormulaPtr p; ProcedurePtr proc;
{
        Ptr p0;
        TermPtr left, right;

        if (p->connective == '=') {
                left = (TermPtr) p->left;
                right = (TermPtr) p->right;
                if ( left->type == VAR && !isInp( p->left, proc ) &&
                	*(left->name)!='#' &&
                	*(left->name)!='@' ) return( 1 );
                if ( right->type == VAR && !isInp( p->right, proc ) &&
                	*(right->name)!='#' &&
                	*(right->name)!='@' ) {
                        p0 = p->left;
                        p->left = p->right;
                        p->right = p0;
                        return( 1 );
                }
        }
        return( 0 );
}

FUN int isNotAssign( p, proc )
FormulaPtr p; ProcedurePtr proc;
{
        return( !isAssign( p, proc ) );
}

FUN int isInit( p, proc )
FormulaPtr p; ProcedurePtr proc;
{
        Ptr p0;
        TermPtr left, right;

        if (p->connective == '=') {
                left = (TermPtr) p->left;
                right = (TermPtr) p->right;
                if ( right->type == VAR && *(left->name)=='#' ) return( 1 );
                if ( left->type == VAR && *(right->name)=='#' ) {
                        p0 = p->left;
                        p->left = p->right;
                        p->right = p0;
                        return( 1 );
                }
        }
        return( 0 );
}

FUN int isNotInit( p, proc )
FormulaPtr p; ProcedurePtr proc;
{
        return( !isInit( p, proc ) );
}
