#include "sentence.h"

FUN FormulaPtr CalElem( s )
SentencePtr s; 
{
	FormulaPtr p;

	p = FormulaCopy( s->postCond );
	p = FormulaSubstSim( p, s->assignList );

	s->preCond = p;
	return( p );
}

FUN FormulaPtr CalSeq( s )
SentencePtr s; 
{
	FormulaPtr p;

	AddPostCond( s->labels2, s->postCond );
	p = CalPreCond( s->labels2 );

	AddPostCond( s->labels1, p );
	p = CalPreCond( s->labels1 );

	s->preCond = p;
	return( p );
}

FUN FormulaPtr CalCase( s )
SentencePtr s; 
{
	FormulaPtr p1, p2;

	AddPostCond( s->labels1, s->postCond );
	p1 = CalPreCond( s->labels1 );

	AddPostCond( s->labels2, s->postCond );
	p2 = CalPreCond( s->labels2 );

	s->preCond = CombineCaseCond( p1, p2, s->cond );
	return( s->preCond );
}


FUN FormulaPtr CalLoop( s )
SentencePtr s; 
{
	FormulaPtr p1, p2;

	p2 = GetPostCond( s->labels1 );
	p1 = CalPreCond( s->labels1 );

/*alternative one
if (aLOOP) {
        MakeLoopAssumption( s->cond, p2, p1 );
        MakeLoopAssumption(
                CombineCond( NULL, '~', s->cond ),
                c2, s->postCond );
        MakeLoopAssumption(
                CombineCond( NULL, '~', s->cond ),
                c1, s->postCond );
        s->preCond = p1;
} else {
*/

        MakeLoopAssumption( s->cond, p2, p1 );
        MakeLoopAssumption(
                CombineCond( NULL, '~', s->cond ),
                p2, s->postCond );
        s->preCond = p2;

	return( s->preCond );
}

