#include "sentence.h"

static char newName[ MOLABEL ];

InitializeNewName()
{
	strcpy( newName, "#@a" );
}

FUN int NewName( s )
char *s;
{	
	int k;

	strcpy( s, newName );
	k = strlen( newName ) - 1;
	if ( newName[ k ] != 'z' ) newName[ k ]++;
	else {
		newName[ k+1 ] = 'a';
		newName[ k+2 ] = 0;
	}
}

FUN int isNotEgenVar( p, proc )
FormulaPtr p; ProcedurePtr proc;
{
        TermPtr t;
        if (p->connective != '=') return( 1 );
        t = (TermPtr) p->right;
        if ( *(t->name) == '@' ) return( 0 );
        t = (TermPtr) p->left;
        if ( *(t->name) == '@' ) return( 0 );
        return( 1 );
}

/*------------------------------------------------------*/

FUN TermPtr FormulaEgenVarFind( t )
FormulaPtr t; 
{
	TermPtr t1;

        if (t==NULL) return( NULL );

        if (t->connective==LALL) {
		return( NULL );
	}
        else if (isLog(t->connective)) {
		t1 = FormulaEgenVarFind( t->left );
		if (t1!=NULL) return( t1 );
		t1 = FormulaEgenVarFind( t->right );
		if (t1!=NULL) return( t1 );
        } else if (isRel(t->connective)) {
		/*assume that EgenVar only appears in terms at first level*/
		t1 = (TermPtr) t->left;
		if (*(t1->name)=='@') return( TermCopy(t1) );
		t1 = (TermPtr) t->right;
		if (*(t1->name)=='@') return( TermCopy(t1) );
        }
        return( NULL );
}

FUN FormulaPtr EgenVarRename( p )
FormulaPtr p;
{
        AssignList c;
        Assign c1;
	TermPtr t, t1;

	t = FormulaEgenVarFind( p );
	while (t!=NULL) {
		t1 = TermCopy( t );
		NewName( t1->name );
		c1.termLeft = t;
                c1.termRight = t1;
                c.assign = &c1;
                c.assignList = NULL;
                p = FormulaSubstSim( p, &c );
		TermFree( t );
		TermFree( t1 );
 		t = FormulaEgenVarFind( p );
        }

	return( p );
}


/*------------------------------------------------------*/

FUN TermPtr FormulaEgenVarFind2( t )
FormulaPtr t; 
{
	TermPtr t1;

        if (t==NULL) return( NULL );

        if (t->connective==LALL) {
		return( NULL );
	}
        else if (isLog(t->connective)) {
		t1 = FormulaEgenVarFind2( t->left );
		if (t1!=NULL) return( t1 );
		t1 = FormulaEgenVarFind2( t->right );
		if (t1!=NULL) return( t1 );
        } else if (isRel(t->connective)) {
		/*assume that EgenVar only appears in terms at first level*/
		t1 = (TermPtr) t->left;
		if (*(t1->name)=='#' && (t1->name)[1]!='@') 
			return( TermCopy(t1) );
		t1 = (TermPtr) t->right;
		if (*(t1->name)=='#' && (t1->name)[1]!='@') 
			return( TermCopy(t1) );
        }
        return( NULL );
}

FUN FormulaPtr EgenVarRename2( p )
FormulaPtr p;
{
        AssignList c;
        Assign c1;
	TermPtr t, t1;

	t = FormulaEgenVarFind2( p );
	while (t!=NULL) {
		t1 = TermCopy( t );
		NewName( t1->name );
		c1.termLeft = t;
                c1.termRight = t1;
                c.assign = &c1;
                c.assignList = NULL;
                p = FormulaSubstSim( p, &c );
		TermFree( t );
		TermFree( t1 );
 		t = FormulaEgenVarFind2( p );
        }

	return( p );
}


