#include "term.h"

/*------------------------------------------------------------------*/

FUN int FormulaRead( s, t )
char* s;
FormulaPtr t;
{
	char *ss;
	int j=0;

	ss=s;
	while (*ss) {
		if (isIMP2(ss) && j==0) {
			FormulaPtr t1 = 
				(FormulaPtr) calloc( sizeof( Formula ), 1 );
			FormulaPtr t2 = 
				(FormulaPtr) calloc( sizeof( Formula ), 1 );

			*ss = 0;
			FormulaRead( s, t1 );
			FormulaRead( ss+2, t2 );

			t->connective = IMP;
			t->left = t1;
			t->right = t2;
			return;
		} 
		else if (*ss=='(') j++;
		else if (*ss==')') j--;
		ss++;
	}
	ss = s;
	while (*ss) {
		if (*ss==LOR && j==0) {
			FormulaPtr t1 = 
				(FormulaPtr) calloc( sizeof( Formula ), 1 );
			FormulaPtr t2 = 
				(FormulaPtr) calloc( sizeof( Formula ), 1 );

			*ss = 0;
			FormulaRead( s, t1 );
			FormulaRead( ss+1, t2 );

			t->connective = LOR;
			t->left = t1;
			t->right = t2;
			return;
		} 
		else if (*ss=='(') j++;
		else if (*ss==')') j--;
		ss++;
	}
	ss = s;
	while (*ss) {
		if (*ss==LAND && j==0) {
			FormulaPtr t1 = 
				(FormulaPtr) calloc( sizeof( Formula ), 1 );
			FormulaPtr t2 = 
				(FormulaPtr) calloc( sizeof( Formula ), 1 );

			*ss = 0;
			FormulaRead( s, t1 );
			FormulaRead( ss+1, t2 );

			t->connective = LAND;
			t->left = t1;
			t->right = t2;
			return;
		} 
		else if (*ss=='(') j++;
		else if (*ss==')') j--;
		ss++;
	}
	FormulaRead1( s, t );
}

FUN int FormulaRead1( s, t )
char* s;
FormulaPtr t;
{
	char *ss=s;
	int j=0;

	if (*s==0) return 0;

	if ( *ss=='(' ) {
		j++;
		while (*ss && j) {
			ss++;
			if ( *ss==')' ) j--;
			else if ( *ss=='(' ) j++;
		}
		*ss=0;
		FormulaRead( s+1, t );
	} else if (*ss=='$' && *(ss+1)=='F') {
		FormulaPtr t1 = (FormulaPtr) calloc( sizeof( Formula ), 1 );
		ss += 2;
		t1->connective = LTRUE;
		t1->left = NULL;
		t1->right = NULL;
		t->connective = LNEG;
		t->left = NULL;
		t->right = t1;
	} else if (*ss=='$' && *(ss+1)==LTRUE) {
		ss++;
		t->connective = *ss++;
		t->left = NULL;
		t->right = NULL;
	} else if (*ss==LNEG) {
		t->connective = *ss++;
		t->left = NULL;
		t->right = (Ptr) calloc( sizeof( Formula ), 1 );
		ss += FormulaRead1( ss, t->right );
	} else if (*ss=='$' && *(ss+1)=='E') {
		FormulaPtr t1 = (FormulaPtr) calloc( sizeof( Formula ), 1 );
		FormulaPtr t2 = (FormulaPtr) calloc( sizeof( Formula ), 1 );
		ss += 2;
		t1->connective = LALL;
		t1->left = (Ptr) calloc( sizeof( Term ), 1 );
		ss += TermRead( ss, t1->left );;
		if (*ss==':') ss++; else Error( "FOR ALL" ); 

		t2->connective = LNEG;
		t2->left = NULL;
		t2->right = (Ptr) calloc( sizeof( Formula ), 1 );
		ss += FormulaRead1( ss, t2->right );

		t1->right = t2;

		t->connective = LNEG;
		t->left = NULL;
		t->right = t1;
	} else if (*ss=='$' && *(ss+1)==LALL) {
		ss++;
		t->connective = *ss++;
		t->left = (Ptr) calloc( sizeof( Term ), 1 );
		ss += TermRead( ss, t->left );;
		if (*ss==':') ss++; else Error( "FOR ALL" ); 
		t->right = (Ptr) calloc( sizeof( Formula ), 1 );
		ss += FormulaRead1( ss, t->right );
	} else {
		t->left = (Ptr) calloc( sizeof( Term ), 1 );
		t->right = (Ptr) calloc( sizeof( Term ), 1 );

		ss += TermRead( ss, t->left );
		if (isRel( *ss )) {
			t->connective = *ss++;
			ss += TermRead( ss, t->right );
		} else {
			t->right = t->left;
			t->left = NULL;
			t->connective = PRED;
		}
	}

	return( ss - s );
}

/*--------------------------------------------------*/

FUN FormulaPrint( t, s )
FormulaPtr t; char* s; 
{
	if (t==NULL) { *s=0; return; }

	if (t->connective == LOR ) {
		sprintf( s, "(" );
		FormulaPrint( t->left, s+1 );
		s += strlen( s );
		sprintf( s, "%c", LOR );
		FormulaPrint( t->right, s+1 );
		s += strlen( s );
		sprintf( s, ")" );
	} else if (t->connective == LAND) {
		sprintf( s, "(" );
		FormulaPrint( t->left, s+1 );
		s += strlen( s );
		sprintf( s, "%c", t->connective );
		FormulaPrint( t->right, s+1 );
		s += strlen( s );
		sprintf( s, ")" );
	} else if (t->connective == IMP) {
		sprintf( s, "((" );
		FormulaPrint( t->left, s+2 );
		sprintf( s+strlen(s), ")" );
		s += strlen( s );
		sprintf( s, "%c%c", IMP1, IMP2 );
		FormulaPrint( t->right, s+2 );
		s += strlen( s );
		sprintf( s, ")" );
	} else if (t->connective==PRED) {
		TermPrint( t->right, s );
		s += strlen( s );
	} else if (t->connective == LTRUE ) {
		sprintf( s, "$%c", t->connective );
	} else if (t->connective == LNEG ) {
		sprintf( s, "%c", t->connective );
		FormulaPrint( t->right, s+1 );
	} else if (t->connective == LALL ) {
		sprintf( s, "$%c", t->connective );
		TermPrint( t->left, s+2 );
		s += strlen( s );
		sprintf( s, "%c", ':' );
		FormulaPrint( t->right, s+1 );
	} else if (isRel(t->connective)) {
		TermPrint( t->left, s );
		s += strlen( s );
		sprintf( s, "%c", t->connective );
		TermPrint( t->right, s+1 );
		s += strlen( s );
	} else *s = 0;
}

