#include "proof.h"
 
SequentList sequentList;
SequentListPtr sequentListPtr = &sequentList;

extern SequentListPtr PactSequentList();
extern int SimplifySequentUseRules();
extern int SimplifySequentUseFunAxioms();
extern int SimplifySequentUsePremisses();
extern int SimplifySequentUseAxioms();
extern int SimplifySequentEvaluate();

FUN SequentPtr NewSequent( s )
SequentPtr s;
{
	SequentPtr p;

	sequentListPtr->sequent = (SequentPtr) calloc( sizeof(Sequent), 1 );
	p = sequentListPtr->sequent;
        p->formulaList1 = FormulaListCopy( s->formulaList1 );
        p->formulaList2 = FormulaListCopy( s->formulaList2 );
	strcpy( p->remark, s->remark );
        sequentListPtr->sequentList = (SequentListPtr) calloc(
                sizeof(SequentList), 1 );
        sequentListPtr = sequentListPtr->sequentList;
        return( p );
}

FUN int SequentPrint( note, ss )
char *note; char *ss;
{
	int ok, ok1;
	char *s;
        SequentListPtr p = &sequentList;

	if (note==NULL || *note==0 ) ok = 1; else ok = 0;

	*ss=0;
        while( p!=NULL) {
		if (p->sequent!=NULL) {
			ok1 = ok || (strcmp( p->sequent->remark, note)==0);
			if (ok1) {
s = ss+strlen(ss);
				FormulaListPrint( 
					p->sequent->formulaList1, 
					ss+strlen(ss) );
if (*s==0) {
	sprintf( ss+strlen(ss), "$T" );
}
				sprintf( ss+strlen(ss), "\n =>\n  " );

s = ss+strlen(ss);
				FormulaListPrint( 
					p->sequent->formulaList2, 
					ss+strlen(ss) );
if (*s==0) {
	sprintf( ss+strlen(ss), "$F" );
}
				sprintf( ss+strlen(ss), "\n\n" );
			}
		}
		p = p->sequentList;
        }
}


 
/*-------------------------------------------------------*/

FUN int SimplifySequentAll()	/*5 steps*/
{	
	SimplifySequentList( SimplifySequentUseRules );
Log( "Simplify", SequentListPrint );
	SimplifySequentList( SimplifySequentUseFunAxioms );
Log( "FunAxioms", SequentListPrint );
	SimplifySequentList( SimplifySequentUsePremisses );
Log( "Premisses", SequentListPrint );
	SimplifySequentList( SimplifySequentUseFunAxioms );
Log( "FunAxioms", SequentListPrint );
	SimplifySequentList( SimplifySequentUseAxioms );
Log( "RemoveEmpty", SequentListPrint );
}

FUN SequentListPtr PactSequentList( p )
SequentListPtr p;
{
	SequentListPtr q;

	if (p->sequent==NULL) return( p );
	if (p->sequent->formulaList1==NULL && 
 	    p->sequent->formulaList2==NULL) {
		q = PactSequentList( p->sequentList );
		p->sequent = q->sequent;
		p->sequentList = q->sequentList;
	} else 
		p->sequentList = PactSequentList( p->sequentList );

	return( p );
}


FUN int SimplifySequentList( f )
int (*f)();
{
	SequentListPtr p = &sequentList;
	while( p!=NULL) {
		f( p->sequent );
		p = p->sequentList;
	}
	PactSequentList( &sequentList );
}

/*--------------------------------------------------------*/

