#include "proof.h"
 

extern FormulaPtr ElemEvaluate();
extern FormulaPtr SimplifyEqual();
extern FormulaPtr SimplifyLess();
extern FormulaPtr SimplifyGreater();

/*-------------------------------------------------------*/


FUN int SimplifySequentEvaluate( s )
SequentPtr s;
{
	FormulaListPtr fl1, fl2;

	if (s==NULL) return( 1 );

	fl1 = s->formulaList1;
	fl2 = s->formulaList2;


	while( fl1 != NULL ) {
		fl1->formula == ElemEvaluate( fl1->formula );
		fl1=fl1->formulaList;
	}
	
	while( fl2 != NULL ) {
		fl2->formula == ElemEvaluate( fl2->formula );
		fl2=fl2->formulaList;
	}
	
}

FUN FormulaPtr ElemEvaluate( p )
FormulaPtr p;
{
	if ( p==NULL ) return( NULL );

	switch( p->connective ) {
		case '=':
			p = SimplifyEqual( p );
			break;
		case '<':
			p = SimplifyLess( p );
			break;
		case '>': 
			p = SimplifyGreater( p );
			break;
		default:
			break;
	}
	return( p );
}

