#include "proof.h"

extern FormulaPtr ApplyFunctionAxiomsFormula();
extern FormulaPtr ApplyFunctionAxiomsElem();
extern FormulaPtr FunMinus();

extern TermPtr FunRewrite();
extern TermPtr FunMinus1();
extern TermPtr FunFaculty();
extern TermPtr FunCommutative();

FUN int SimplifySequentUseFunAxioms( s )
SequentPtr s;
{
        FormulaListPtr fl1, fl2;

        if (s==NULL) return( 1 );

        fl1 = s->formulaList1;
        fl2 = s->formulaList2;


        while( fl1 != NULL ) {
                fl1->formula == ApplyFunctionAxiomsFormula( fl1->formula );
                fl1=fl1->formulaList;
        }

        while( fl2 != NULL ) {
                fl2->formula == ApplyFunctionAxiomsFormula( fl2->formula );
                fl2=fl2->formulaList;
        }

}

FUN FormulaPtr ApplyFunctionAxiomsFormula( c )
FormulaPtr c;
{
	FormulaPtr c1, c2;

	if ( c==NULL ) return( NULL );

	switch( c->connective ) {
		case '~':
		case '^':
		case '|':
			c->left = (Ptr) ApplyFunctionAxiomsFormula( c->left );
			c->right = (Ptr) ApplyFunctionAxiomsFormula( c->right );
			break;
		case '=':
		case '<':
		case '>': 
			c->left = (Ptr) FunRewrite( c->left );
			c->right = (Ptr) FunRewrite( c->right );
			c = FunMinus( c );
			break;
		default:
			break;
	}
	return( c );
}

/*--------------------------------------------------------*/

FUN FormulaPtr FunMinus( c )
FormulaPtr c;
{
	TermPtr t1, t2;
	TermListPtr t5;

	t1 = (TermPtr) c->left;
	t2 = (TermPtr) c->right;

	if ( strcmp( t1->name, "0") == 0 ) {
		if ( strcmp( t2->name, "-") == 0 ) {
			c->left = (Ptr) ((TermListPtr)(t2->termList))->term;
			t5 = (TermListPtr) ((TermListPtr)(t2->termList))->termList;
			c->right = (Ptr) t5->term;
			if (c->connective=='<') (c->connective='>');
			else if (c->connective=='>') {
				t1 = (TermPtr) c->left;
				c->left = c->right;
				c->right = (Ptr) t1;
			}
		}
	}
	else if ( strcmp( t2->name, "0") == 0 ) {
		if ( strcmp( t1->name, "-") == 0 ) {
			c->left = (Ptr) ((TermListPtr)(t1->termList))->term;
			t5 = (TermListPtr) ((TermListPtr)(t1->termList))->termList;
			c->right = (Ptr) t5->term;
		}
	}
	return( c );
}

/*--------------------------------------------------------*/

FUN TermPtr FunMin( t )
TermPtr t;
{
	TermListPtr t1,t2,t3,t4;
	if (t==NULL) return( NULL );

	if ( strcmp( t->name, "+") == 0 ) {
		t1 = (TermListPtr) t->termList;
		t2 = (TermListPtr) t1->termList;

		t1->term = FunRewrite( t1->term );
		t2->term = FunRewrite( t2->term );

		if ( strcmp( t1->term->name, "-") == 0 ) {
			t3 = (TermListPtr) t1->term->termList;
			t4 = (TermListPtr) t3->termList;
			if (TermEqual( t2->term, t4->term)) return( t3->term );
		}
	}

	if ( strcmp( t->name, "-") == 0 ) {
		t1 = (TermListPtr) t->termList;
		t2 = (TermListPtr) t1->termList;

		t1->term = FunRewrite( t1->term );
		t2->term = FunRewrite( t2->term );

		if (TermEqual( t1->term, t2->term )) {
			strcpy( t->name, "0" );
			t->termList = NULL;
			t->type = VAR;
		} else if ( strcmp( t1->term->name, "+") == 0 ) {
			t3 = (TermListPtr) t1->term->termList;
			t4 = (TermListPtr) t3->termList;
			if (TermEqual( t2->term, t4->term)) return( t3->term );
			if (TermEqual( t2->term, t3->term)) return( t4->term );
		}
	}

	return( t );
}

FUN TermPtr FunMinus1( t )
TermPtr t;
{
	TermListPtr t1;
	if (t==NULL) return( NULL );

	t1 = (TermListPtr) t->termList;

	if ( strcmp( t->name, "-1") == 0 ) {
		t1->term = FunRewrite( t1->term );
		if ( strcmp( t1->term->name, "+1") == 0 ) {
			t1 = (TermListPtr) t1->term->termList;
			t = t1->term;
		}
	} else if ( strcmp( t->name, "+1") == 0 ) {
		t1->term = FunRewrite( t1->term );
		if ( strcmp( t1->term->name, "-1") == 0 ) {
			t1 = (TermListPtr) t1->term->termList;
			t = t1->term;
		}
	}

	return( t );
}

FUN TermPtr FunCommutative( t )
TermPtr t;
{
	TermListPtr t1,t2;
	TermPtr tp;

	if (t==NULL) return( NULL );

	if ( strcmp( t->name, "+") == 0 || strcmp( t->name, "*") == 0 ) {
		t1 = (TermListPtr) t->termList;
		t2 = (TermListPtr) ((TermListPtr) t->termList)->termList;
		t1->term = FunRewrite( t1->term );
		t2->term = FunRewrite( t2->term );
		if (strcmp( t1->term->name, t2->term->name )<0) {
			tp = t1->term;
			t1->term = t2->term;
			t2->term = tp;
		} 
	}

	return( t );
}

FUN TermPtr FunFaculty( t )
TermPtr t;
{
	TermListPtr t1;
	TermPtr tp;
	if (t==NULL) return( NULL );

	t1 = (TermListPtr) t->termList;

	if ( strcmp( t->name, "!") == 0 ) {
		t1->term = FunRewrite( t1->term );
		if ( strcmp( t1->term->name, "+1") == 0 ) {
			tp = TermCopy( t1->term );
			strcpy( tp->name, "!" );

			t1->termList = (TermListPtr) calloc( sizeof( TermList ), 1 );
			t1->termList->term = tp;
			strcpy( t->name, "*" );
			t = FunRewrite( t );
		} else if ( strcmp( t1->term->name, "0") == 0 ) {
			strcpy( t->name, "1" );
			t->termList = NULL;
			t->type = VAR;
		} else if ( strcmp( t1->term->name, "1") == 0 ) {
			strcpy( t->name, "1" );
			t->termList = NULL;
			t->type = VAR;
		}
	}
	return( t );
}

FUN TermPtr FunRewrite( t )
TermPtr t;
{
	TermListPtr t1;

	if (strcmp( t->name, "!" )==0) t = FunFaculty( t ); 
	else if (strcmp( t->name, "*" )==0) t = FunCommutative( t ); 
	else if (strcmp( t->name, "+" )==0) t = FunCommutative( FunMin( t ) ); 
	else if (strcmp( t->name, "-" )==0) t = FunMin( t ); 
	else if (strcmp( t->name, "+1" )==0) t = FunMinus1( t ); 
	else if (strcmp( t->name, "-1" )==0) t = FunMinus1( t ); 
	else {
		t1 = (TermListPtr) t->termList;
		while (t1 != NULL) {
			t1->term = FunRewrite( t1->term );
			t1 = t1->termList;
		}
	}
	return( t );
}
