#include "proof.h"

extern FormulaPtr SimplifyEqual();
extern FormulaPtr SimplifyLess();
extern FormulaPtr SimplifyGreater();

/*-------------------------------------------------------*/


FUN Ptr SimplifySequentUseRewrite( c )
FormulaPtr c;
{
	char l1[ MOPROG ], l2[ MOPROG ];
	FormulaPtr p1, p2;

	if ( c==NULL ) return( NULL );

	switch( c->connective ) {
		case LNEG:
			c->right = SimplifySequentUseRewrite( c->right );
			p2 = (FormulaPtr) c->right;
			if (p2->connective==LNEG) return( p2->right );
			break;
		case LALL:
			c->right = SimplifySequentUseRewrite( c->right );
			if (isFreeVarFormula(c->left, c->right)) 
				return(c->right);
/*
			if (isTrue( c->right )) return( c->right );
			if (isFalse( c->right )) return( c->right );
*/
			break;
		case PRED:
			break;
		case LAND:
			c->left = SimplifySequentUseRewrite( c->left );
			c->right = SimplifySequentUseRewrite( c->right );
			p2 = (FormulaPtr) c->right;

			if (isTrue( c->left )) return( c->right );
			if (isFalse( c->left )) return( c->left );
			if (isTrue( c->right )) return( c->left );
			if (isFalse( c->right )) return( c->right );

			FormulaPrint( c->left, l1 );
			FormulaPrint( c->right, l2 );
			if (strcmp( l1, l2 )==0) return( c->left );
			else if (*l1==LNEG) {
				if (strcmp( l1+1, l2 )==0) {
					p2->connective = LTRUE;
					p2->left = NULL;
					p2->right = NULL;
					c->left = NULL;
					c->connective = LNEG;
				}
			} else if (*l2==LNEG) {
				if (strcmp( l1, l2+1 )==0) {
					p2->connective = LTRUE;
					p2->left = NULL;
					p2->right = NULL;
					c->left = NULL;
					c->connective = LNEG;
				}
			} 
			break;
		case LOR:
			c->left = SimplifySequentUseRewrite( c->left );
			c->right = SimplifySequentUseRewrite( c->right );

			if (isTrue( c->left )) return( c->left );
			if (isFalse( c->left )) return( c->right );
			if (isTrue( c->right )) return( c->right );
			if (isFalse( c->right )) return( c->left );

			FormulaPrint( c->left, l1 );
			FormulaPrint( c->right, l2 );
			if (strcmp( l1, l2 )==0) return( c->left );
			else if (*l1==LNEG) {
				if (strcmp( l1+1, l2 )==0) {
					c->connective = LTRUE;
					c->left = NULL;
					c->right = NULL;
				} 
			} else if (*l2==LNEG) {
				if (strcmp( l1, l2+1 )==0) {
					c->connective = LTRUE;
					c->left = NULL;
					c->right = NULL;
				} 
			} 
			break;
		case IMP:
			c->left = SimplifySequentUseRewrite( c->left );
			p1 = (FormulaPtr) c->left;
			c->right = SimplifySequentUseRewrite( c->right );

			if (isTrue( c->left )) return( c->right );
			if (isFalse( c->left )) return( p1->right );
			if (isTrue( c->right )) return( c->right );
			if (isFalse( c->right )) { 
				c->connective == LNEG;
				c->right = c->left;
				c->left = NULL;
				break;
			}

			FormulaPrint( c->left, l1 );
			FormulaPrint( c->right, l2 );
			if (strcmp( l1, l2 )==0 || *l2==LTRUE) {
				c->connective = LTRUE;
				c->left = NULL;
				c->right = NULL;
			} 
			else if (*l1==LNEG) {
				if (strcmp( l1+1, l2 )==0) return( c->right );
			} else if (*l2==LNEG) {
				if (strcmp( l1, l2+1 )==0) return( c->right );
			} 
			break;
		case '=':
			c = SimplifyEqual( c );
			break;
		case '<':
			c = SimplifyLess( c );
			break;
		case '>': 
			c = SimplifyGreater( c );
			break;
		default:
			break;
	}
	return( c );
}

/*-------------------------------------------------------*/


FUN FormulaPtr SimplifyGreater( c )
FormulaPtr c;
{
	TermPtr tp, t1, t2; 
	FormulaPtr c1, c2;
  
        t1 = (TermPtr) c->left;
        t2 = (TermPtr) c->right;

/*
	if (strcmp( t1->name, t2->name )<0 && 
		t1->type == VAR &&
		t2->type == VAR &&
		strcmp( t2->name, "0" )!=0 ) 
	{
		c1 = (FormulaPtr) calloc( sizeof( Formula ), 1 );
        	c1->left = (Ptr) c->right;
        	c1->right = (Ptr) c->left;
		c1->connective = c->connective;

        	c2 = FormulaCopy( c1 );
		c2->connective = '=';

		c->left = NULL;
		c->right = (Ptr) CombineCond( c1, LOR, c2 );
		c->connective = '~';
	}
*/

	if (TermEqual( c->left, c->right )) {
		c->connective = 'T';
		c->left = NULL;
		c->right = NULL;
		c->right = (Ptr) FormulaCopy( c );
		c->connective = '~';
	}

	return( c );
}

FUN FormulaPtr SimplifyLess( c )
FormulaPtr c;
{
	TermPtr c1;

	c1 = (TermPtr) c->left;
	c->left = c->right;
	c->right = (Ptr) c1;
	c->connective = '>';

	return( SimplifyGreater( c ));
}

FUN FormulaPtr SimplifyEqual( c )
FormulaPtr c;
{
	if (TermEqual( c->left, c->right )) {
		c->connective = 'T';
		c->left = NULL;
		c->right = NULL;
	}
	return( c );
}

/*--------------------------------------------------------------*/

FUN int isFreeVarFormula( x, t )
TermPtr x; FormulaPtr t; 
{
	if (t==NULL) return( 1 );

	if (t->connective==LALL) {
		if (TermEqual( x, t->left )) return( 0 );
		else return( isFreeVarFormula( x, t->right )); 
	} else if (isLog(t->connective)) {
		if ( !isFreeVarFormula( x, t->left )) return( 0 );
		if ( !isFreeVarFormula( x, t->right )) return( 0 );
		return( 1 );
	} else if (isRelPred(t->connective)) {
		if ( !isFreeVarTerm( x, t->left )) return( 0 );
		if ( !isFreeVarTerm( x, t->right )) return( 0 );
		return( 1 );
	} 
}



FUN int isFreeVarTerm( x, t )
TermPtr x; TermPtr t; 
{
	if (t==NULL) return( 1 );

	switch (t->type) {
		case ARR:
			return(isFreeVarTermArraySubList( x, t->arraySubList ));
		case FUNC:
			return(isFreeVarTermTermList( x, t->termList ));
		case VAR: 
			return( !TermEqual( x, t ) );
	}
}

FUN int isFreeVarTermArraySubList( x, a )
TermPtr x; ArraySubListPtr a; 
{
	if ( a == NULL ) return( 1 );

	if (!isFreeVarTermExpPairList( x, a->expPairList )) return( 0 );
	if (!isFreeVarTermArraySubList( x, a->arraySubList )) return( 0 );
	return( 1 );
}

FUN int isFreeVarTermExpPairList( x, a )
TermPtr x; ExpPairListPtr a; 
{
	if ( a == NULL ) return( 1 );

	if (!isFreeVarTermExpPair( x, a->expPair )) return( 0 );
	if (!isFreeVarTermExpPairList( x, a->expPairList )) return( 0 );
	return( 1 );
}

FUN int isFreeVarTermExpPair( x, a )
TermPtr x; ExpPairPtr a; 
{
	if (!isFreeVarTermTermList( x, a->subList )) return( 0 );
	if (!isFreeVarTerm( x, a->exp )) return( 0 );
	return( 1 );
}

FUN int isFreeVarTermTermList( x, a )
TermPtr x; TermListPtr a; 
{
	if (a == NULL) return( 1 );

	if (!isFreeVarTerm( x, a->term )) return( 0 );
	if (!isFreeVarTermTermList( x, a->termList )) return( 0 );
	return( 1 );
}
