#include "g.h"
#include "term.h"

#define ELEM 1
#define SEQ 2
#define LOOP 3
#define COND 4
#define CALL 5
#define IND 4

typedef struct Sentence {
	char type;
	FormulaPtr cond;
	char labels[ MOLABEL ];
	char labels1[ MOLABEL ];
	char labels2[ MOLABEL ];
	AssignListPtr assignList;
	FormulaPtr preCond;
	FormulaPtr postCond;
} Sentence, *SentencePtr;

typedef struct SentenceList {
	SentencePtr sentence;
	struct SentenceList* sentenceList;
} SentenceList, *SentenceListPtr;

typedef struct ParamTrippleList {
	char io[ MOLABEL ];
	char type[ MOLABEL ];
	char name[ MOLABEL ];
	struct ParamTrippleList *paramTrippleList;
} ParamTrippleList, *ParamTrippleListPtr;

typedef struct Procedure {
	char name[ MOLABEL ];
	char loc[ MOPROG ];
	char body[ MOLABEL ];
	ParamTrippleListPtr params;
	FormulaPtr preCond;
	FormulaPtr postCond;
	SentenceListPtr sentenceList;
} Procedure, *ProcedurePtr;

typedef struct ProcedureList {
	ProcedurePtr procedure;
	struct ProcedureList* procedureList;
} ProcedureList, *ProcedureListPtr;

extern int AssignRead();

extern ProcedureList procedureList;
extern ProcedureListPtr currentProcedureList;
extern ProcedurePtr currentProcedure;
extern SentenceListPtr sp;

typedef struct Assumption {
	FormulaPtr formula1;
	FormulaPtr formula2;
	char procName[ MOLABEL ];
} Assumption, *AssumptionPtr;

typedef struct AssumptionList {
	AssumptionPtr assumption;
	struct AssumptionList* assumptionList;
} AssumptionList, *AssumptionListPtr;

extern AssumptionList assumptionList;

extern FormulaPtr CalElem();
extern FormulaPtr CalSeq();
extern FormulaPtr CalCase();
extern FormulaPtr CalLoop();
extern FormulaPtr CalCall();

extern SentencePtr Sentence2Ptr();

extern FormulaPtr GetPostCond();
extern FormulaPtr CalPreCond();
extern FormulaPtr CombineCond();
extern FormulaPtr CombineCaseCond();

extern ProcedurePtr Procedure2Ptr();
extern FormulaListPtr Formula2FormulaList();
extern FormulaPtr FormulaList2Formula();
extern AssignListPtr FormulaList2AssignList();
extern FormulaListPtr FormulaListRewrite();
extern FormulaListPtr FormulaListSelect();
extern FormulaListPtr FormulaListSubstSim();
extern int isInit();
extern int isNotInit();
extern int isAssign();
extern int isNotAssign();
extern int isNotEgenVar();

extern int isInp();
extern int isIop();
extern AssignListPtr AssignListSelect();
extern FormulaPtr EgenVarRename();
