#include "sentence.h"

FUN ProcedureReadList( s )
char *s;
{
        ProcedureListPtr pl = &procedureList;
	if (*s==0) return;

	while( pl->procedure != NULL ) pl = pl->procedureList;

	pl->procedure = (ProcedurePtr) calloc( sizeof( Procedure ), 1 );
	s += ProcedureRead( s, pl->procedure );

        pl->procedureList = (ProcedureListPtr)
                calloc( sizeof( ProcedureList ), 1 );

	ProcedureReadList( s );
}

FUN int ProcedureRead( s, p )
char* s;
ProcedurePtr p;
{
	char l1[ MOLINE ];
	char l2[ MOLINE ];
	char l3[ MOLINE ];
	char l5[ MOLABEL ];
	FormulaPtr c1, c2;
	char *ss = s;

	if (*s==0) return( 0 );

	currentProcedure = p;
	sp = p->sentenceList = 
		(SentenceListPtr) calloc( sizeof( SentenceList ), 1 );


	if (isInv( s )) {
		c1 = (FormulaPtr) calloc( sizeof( Formula ), 1 );
		s += AssertionRead( s, c1 );
	} else c1==NULL;

	if ( strncmp( s, "%PROC", 5 )==0 ) { 
		s+=5; 
		s += ProcHeadRead( s, l1, '(', ')' );
		if ( strncmp( s, "==", 2 )==0 ) s+=2; 

		if ( strncmp( s, "%LOC", 4 )==0 ) { 
			s+=4; 
			s += ProcHeadRead( s, l2, '[', ']' );
		} else *l2 = 0;
		if ( strncmp( s, "%STM", 4 )==0 ) s+=4; 
	} 

	s += ProcHeadRead( s, l3, '[', ']' );

	SentenceRead( l3, l5 );

	if (isInv( s )) {
		c2 = (FormulaPtr) calloc( sizeof( Formula ), 1 );
		s += AssertionRead( s, c2 );
	} else c2=NULL;

	ProcedureMake( p, c1, c2, l1, l2, l5 );

	return( s - ss );
}


FUN int ProcHeadRead( s, l, c1, c2 )
char *s;
char *l;
char c1, c2;
{
	int i, j;

	i = 0; 
	while ( s[ i ] != c1 ) i++;
	i++; j=1;
	while( s[ i ] && j ) {
		if ( s[ i ] == c1 ) j++;
		if ( s[ i ] == c2 ) j--;
		i++;
	}
	strncpy( l, s, i );
	l[ i ] = 0;

	return( i );
}


FUN int ProcedureMake( proc, c1, c2, head, loc, body )
ProcedurePtr proc;
FormulaPtr c1, c2 ;
char *head, *loc, *body;
{
	ParamTrippleListPtr q;
	char *s, *s1, *s2, *s3;

	s = proc->name;
	while( *head != '(' ) *s++ = *head++;

	head++; *s = 0;

	if ( *head != ')' ) {
		proc->params = (ParamTrippleListPtr) 
			calloc( sizeof( ParamTrippleList ), 1 );
		q = proc->params;
		while( 1 ) {
		
			s1 = q->io;
			s2 = q->name;
			s3 = q->type;
	
			head += ReadTo( head, s1, '/', '/' ) + 1;

			if (strcmp( s1, "%IOP")==0) {
				head += ReadTo( head, s2, ':', ':' ) + 1;
				head += ReadTo( head, s3, ';', ')' );
			} else if (strcmp( s1, "%INP")==0) {
				head += ReadTo( head, s2, ':', ':' ) + 1;
				head += ReadTo( head, s3, ';', ')' );
			}
			if ( *head==0 || *head == ')' ) break; else *head++;
			q->paramTrippleList = (ParamTrippleListPtr) 
				calloc( sizeof( ParamTrippleList ), 1 );
			q = q->paramTrippleList;
		}
	}

	strcpy( proc->loc, loc );
	strcpy( proc->body, body );

	proc->preCond = c1;
	proc->postCond = c2;

}

FUN int AssertionRead( s, c1 )
char *s;
FormulaPtr c1;
{
	int k;
	char l3[ MOLINE ];

	if ( *s != '{' ) return( 0 );
	k = ProcHeadRead( s, l3, '{', '}' );
	l3[ strlen( l3 ) - 1 ] = 0;
	FormulaRead( l3+1, c1 );

	return( k );
}

FUN int ReadTo( s, s1, c1, c2 )
char *s, *s1;
char c1, c2;
{
	int i=0;
	while (*s && *s!=c1 && *s!= c2 ) { *s1++ = *s++; i++; }
	*s1 = 0;
	if (*s==0) { Error( "ReadTo" ); }
	return( i );
}

/*------------------------------------------------------------*/

FUN int ProcedurePrint( p, ss )
ProcedurePtr p;
char *ss;
{
        char s1[ MOPROG ];
	ParamTrippleListPtr q;

	currentProcedure = p;

	*ss = 0;
        FormulaPrint( p->preCond, s1 );
        sprintf( ss+strlen(ss), "{ %s }\n", s1 );

        sprintf( s1, "%s %s(", "%PROC", p->name );
        strcat( ss, s1 );

	q = p->params;
 
/*
	while( q->paramTrippleList != NULL ) {
*/
	while( q != NULL ) {
		if (q->paramTrippleList==NULL ) break;
                sprintf( s1, "%s/%s:%s;", q->io, q->name, q->type );
                strcat( ss, s1 );
		q = q->paramTrippleList;
        }
 
/*
	if ( q->paramTrippleList != NULL ) {
*/
	if ( q != NULL ) {
                sprintf( s1, "%s/%s:%s", q->io, q->name, q->type );
                strcat( ss, s1 );
        }
 
        sprintf( s1, ")==\n" );
        strcat( ss, s1 );

        if ( p->loc != NULL && *(p->loc) != 0 ) {
                sprintf( s1, "%s %s\n", "%LOC", p->loc );
                strcat( ss, s1 );
        }
 
 
        sprintf( s1, "%s", "%STM [ \n" );
        strcat( ss, s1 );
 
        SentencePrint( p->body, ss+strlen(ss), IND );
        sprintf( ss + strlen(ss), "]\n" );

        FormulaPrint( p->postCond, s1 );
        sprintf( ss+strlen(ss), "{ %s }\n", s1 );

}
 
FUN int ProcedureListPrint( ss )
char *ss;
{
	ProcedureListPtr pl = &procedureList;

	while( pl->procedureList != NULL ) {
		ProcedurePrint( pl->procedure, ss );
		strcat( ss, "\n" );
		ss += strlen( ss );
		pl = pl->procedureList;
        }
}

/*--------------------------*/

FUN ProcedurePtr Procedure2Ptr( l )
char *l;
{
        ProcedureListPtr p = &procedureList;
 
        while ( p!=NULL ) {
                if (strcmp( p->procedure->name, l )==0) {
                        return( p->procedure );
                }
        	p = p->procedureList;
        }
        return( NULL );
}        
 
