#include "g.h"


#define ARR 1
#define VAR 2
#define FUNC 3

typedef struct Term {
	char type;			/* array, var, fun */
	char name[ MOLINE ];
	Ptr termList;			/* TermList */
	Ptr arraySubList;		/* ArraySubList */
} Term, *TermPtr;

typedef struct TermList {
	TermPtr term;
	struct TermList* termList;
} TermList, *TermListPtr;

typedef struct ExpPair {
	TermListPtr subList;
	TermPtr exp;
} ExpPair, *ExpPairPtr;

typedef struct ExpPairList {
	ExpPairPtr expPair;
	struct ExpPairList* expPairList;
} ExpPairList, *ExpPairListPtr;

typedef struct ArraySubList {
	ExpPairListPtr expPairList;
	struct ArraySubList* arraySubList;
} ArraySubList, *ArraySubListPtr;

typedef struct Assign {
	TermPtr termLeft;
	TermPtr termRight;
} Assign, *AssignPtr;

typedef struct AssignList {
	AssignPtr assign;
	struct AssignList* assignList;
} AssignList, *AssignListPtr;

extern TermPtr TermSubstSim( /* t, s */ );

extern int TermRead( /* s, t */ );
extern int TermPrint( /* t, s */ );
extern int TermEqual( /*t1, t2 */ );
extern TermPtr TermCopy( /* t */ );
extern TermPtr TermCopy1( /* t */ );
extern TermPtr TermFunction( /* t, s, f */ );
extern TermListPtr TermCopyTermList1( /* t */ );
extern void TermFree( /* t */ );

typedef struct Formula {
	char connective; 
	Ptr left; Ptr right;
} Formula, *FormulaPtr;

typedef struct FormulaList {
	FormulaPtr formula;
	struct FormulaList* formulaList;
} FormulaList, *FormulaListPtr;

extern FormulaPtr FormulaSubstSim( /* t, s */ );
extern int FormulaRead( /* s, t */ );
extern int FormulaPrint( /* t, s */ );
extern FormulaPtr FormulaCopy( /* f */ );
