#include "term.h"
extern TermPtr TermCopy();
extern ArraySubListPtr TermCopyArraySubList();
extern ExpPairListPtr TermCopyExpPairList();
extern ExpPairPtr TermCopyExpPair();
extern TermListPtr TermCopyTermList();
extern TermListPtr TermCopyTermList1();
extern void TermFree();
extern void TermFreeArraySubList();
extern void TermFreeExpPairList();
extern void TermFreeExpPair();
extern void TermFreeTermList();

/*------------------------------------------------------------------*/

FUN TermPtr TermCopy( t )
TermPtr t; 
{
	TermPtr t1; 
	if (t==NULL) return( NULL );

	t1 = (TermPtr) calloc( sizeof( Term ), 1 );
	strcpy( t1->name, t->name );
	t1->type = t->type;
	switch (t->type) {
		case ARR:
			t1->arraySubList = (Ptr)
				TermCopyArraySubList( t->arraySubList );
		case FUNC:
			t1->termList = (Ptr) TermCopyTermList( t->termList );
		case VAR: 
			break;
	}
	return( t1 );
}

FUN ArraySubListPtr TermCopyArraySubList( a )
ArraySubListPtr a; 
{
	ArraySubListPtr a1; 
	if ( a == NULL ) return( NULL );
	
	a1 = (ArraySubListPtr) calloc( sizeof( ArraySubList ), 1 );

	a1->expPairList = TermCopyExpPairList( a->expPairList );
	a1->arraySubList = TermCopyArraySubList( a->arraySubList );

	return( a1 );
}

FUN ExpPairListPtr TermCopyExpPairList( a )
ExpPairListPtr a; 
{
	ExpPairListPtr a1; 
	if ( a == NULL ) return( NULL );
	
	a1 = (ExpPairListPtr) calloc( sizeof( ExpPairList ), 1 );

	a1->expPair = TermCopyExpPair( a->expPair );
	a1->expPairList = TermCopyExpPairList( a->expPairList );

	return( a1 );
}

FUN ExpPairPtr TermCopyExpPair( a )
ExpPairPtr a; 
{
	ExpPairPtr a1; 
	if ( a == NULL ) return( NULL );
	
	a1 = (ExpPairPtr) calloc( sizeof( ExpPair ), 1 );

	a1->subList = TermCopyTermList( a->subList );
	a1->exp = TermCopy( a->exp );

	return( a1 );
}

FUN TermListPtr TermCopyTermList( a )
TermListPtr a; 
{
	TermListPtr a1; 
	if ( a == NULL ) return( NULL );
	
	a1 = (TermListPtr) calloc( sizeof( TermList ), 1 );

	a1->term = TermCopy( a->term );
	a1->termList = TermCopyTermList( a->termList );

	return( a1 );
}

/*----------------------------------------------------------*/

FUN TermListPtr TermCopyTermList1( a )
TermListPtr a; 
{
	TermListPtr a1; 
	if ( a == NULL ) return( NULL );
	
	a1 = (TermListPtr) calloc( sizeof( TermList ), 1 );

	a1->term = TermCopy1( a->term );
	a1->termList = TermCopyTermList1( a->termList );

	return( a1 );
}

FUN TermPtr TermCopy1( t )
TermPtr t; 
{
	TermPtr t1; 
	t1 = TermCopy( t );
	t1->type += 10;

	return( t1 );
}

/*------------------------------------------------------------------*/

FUN void TermFree( t )
TermPtr t; 
{
	if (t==NULL) return;
	switch (t->type) {
		case ARR:
			TermFreeArraySubList( t->arraySubList );
		case FUNC:
			TermFreeTermList( t->termList );
		case VAR: 
			break;
	}
	free( t );
}

FUN void TermFreeArraySubList( a )
ArraySubListPtr a; 
{
	if (a==NULL) return;
	TermFreeExpPairList( a->expPairList );
	TermFreeArraySubList( a->arraySubList );
	free( a );
}

FUN void TermFreeExpPairList( a )
ExpPairListPtr a; 
{
	if (a==NULL) return;
	TermFreeExpPair( a->expPair );
	TermFreeExpPairList( a->expPairList );
	free( a );
}

FUN void TermFreeExpPair( a )
ExpPairPtr a; 
{
	if (a==NULL) return;
	TermFreeTermList( a->subList );
	TermFree( a->exp );
	free( a );
}

FUN void TermFreeTermList( a )
TermListPtr a; 
{
	if (a==NULL) return;
	TermFree( a->term );
	TermFreeTermList( a->termList );
	free( a );
}

