#include "term.h"

/*------------------------------------------------------------------*/

FUN int TermRead( s, t )
char* s;
TermPtr t;
{
	char *ss=s;

	ss += GetWord( ss, t->name );
	if (strlen( t->name)==0) Error( "*** Missing name ***" );

	if (*ss == '(' ) { 
		ss++;
		t->type = FUNC;
		t->termList = (Ptr) calloc( sizeof( TermList ), 1 );
		ss += TermReadTermList( ss, t->termList );
		if (*ss == ')' ) ss++; else Error( "*** Missing ) ***" );
	} else if (*ss == '[' ) { 
		ss++;
		t->type = ARR;
		t->termList = (Ptr) calloc( sizeof( TermList ), 1 );
		ss += TermReadTermList( ss, t->termList );
		if (*ss == ']' ) ss++; else Error( "*** Missing ] ***" );
	} else t->type = VAR;

	return( ss-s );
}

FUN int TermReadTermList( s, p )
char *s;
TermListPtr p;
{
	char *ss=s;

	p->term = (TermPtr) calloc( sizeof( Term ), 1 );
	ss += TermRead( ss, p->term );
	while (*ss==',') {
		ss++;
		p->termList = (TermListPtr) calloc( sizeof( TermList ), 1 );
		p = p->termList;;
		p->term = (TermPtr) calloc( sizeof( Term ), 1 );
		ss += TermRead( ss, p->term );
	}

	return( ss-s );
}

FUN int GetWord( s, s1 )
char *s, *s1;
{
	char *ss=s;
        while ( !(isPdel( *ss )) && !isIMP2( ss )) *s1++ = *ss++;
	*s1 = 0;
	return( ss-s );
}

/*------------------------------------------------------------------*/

FUN TermPrint( t, s )
TermPtr t; char* s; 
{
	sprintf( s, "%s", t->name );
	s += strlen( s );
	switch (t->type) {
		case ARR:
			if (t->arraySubList != NULL ) {
				sprintf( s, "[" );
				TermPrintArraySubList( t->arraySubList, s+1 );
				s += strlen( s );
				sprintf( s, "]" );
				s += strlen( s );
			}
			sprintf( s, "[" );
			TermPrintTermList( t->termList, s+1 );
			s += strlen( s );
			sprintf( s, "]" );
			break;
		case FUNC:
			sprintf( s, "(" );
			TermPrintTermList( t->termList, s+1 );
			s += strlen( s );
			sprintf( s, ")" );
			break;
		case VAR: 
			break;
	}
}

FUN TermPrintArraySubList( a, s )
ArraySubListPtr a; char* s;
{
	if ( a == NULL ) return( NULL );

	sprintf( s, "[" );
	TermPrintExpPairList( a->expPairList, s+1 );
	s += strlen( s );
	sprintf( s, "]" );
	TermPrintArraySubList( a->arraySubList, s+1 );
}

FUN TermPrintExpPairList( a, s )
ExpPairListPtr a; char* s;
{
	TermPrintExpPair( a->expPair, s );

	if ( a->expPairList == NULL ) return( NULL );
	s += strlen( s );
	sprintf( s, "," );
	TermPrintExpPairList( a->expPairList, s+1 );
}

FUN TermPrintExpPair( a, s )
ExpPairPtr a; char* s;
{
	sprintf( s, "(" );
	TermPrintTermList( a->subList, s+1 );
	s += strlen( s );
	sprintf( s, ")->" );
	TermPrint( a->exp, s+3 );
}

FUN TermPrintTermList( a, s )
TermListPtr a; char* s;
{
	TermPrint( a->term, s );

	if (a->termList == NULL) return;
	s += strlen( s );
	sprintf( s, "," );
	TermPrintTermList( a->termList, s+1 );
}

/*-------------------------------------------------------------*/



ShowExpPairList( a )
ExpPairListPtr a;
{
	char s0[ MOPROG ];

	TermPrintExpPairList( a, s0 );
	printf( "ExpPairList: %s\n", s0 );
}
