#include "term.h"

/*----------------------------------------------------------------*/

FUN TermPtr TermSubstListf( t, sl )
TermPtr t; AssignListPtr sl; 
{
	ExpPairListPtr a1, a0 = NULL;
	ExpPairPtr a2;
	ArraySubListPtr a3;
	TermPtr t1;
	int first = 1;

	if( t->type != ARR ) {
		while (sl!=NULL) {
			t1 = sl->assign->termLeft;
			if ( VarEqual( t, t1 ) ) {
				TermFree( t );
				t1 = TermCopy1( sl->assign->termRight);
				return( t1 );
			}
			sl = sl->assignList;
		}
		return( NULL );
	} 

	while (sl!=NULL) {
		t1 = sl->assign->termLeft;
		if (strcmp( t->name, t1->name)==0) {

			if (t1->type==VAR && sl->assign->termRight->type==VAR) {
				/*parameter substitution*/
				strcpy( t->name, sl->assign->termRight->name );
				return( t );
			}

			/* (t1->type==ARR) */
			if (first) {
				a1 = a0 = (ExpPairListPtr)
					calloc( sizeof(ExpPairList), 1 );
				a2 = a1->expPair = (ExpPairPtr)
					calloc( sizeof(ExpPair), 1 );
				a2->subList = TermCopyTermList1( t1->termList );
				a2->exp = TermCopy1( sl->assign->termRight );
				first = 0; 
			} else {
				a1->expPairList = (ExpPairListPtr)
					calloc( sizeof(ExpPairList), 1 );
				a1 = a1->expPairList;
				a2 = a1->expPair = (ExpPairPtr)
					calloc( sizeof(ExpPair), 1 );
				a2->subList = TermCopyTermList1( t1->termList );
				a2->exp = TermCopy1( sl->assign->termRight );
			} 
		}
		sl = sl->assignList;
	}

	if (a0 != NULL ) {
		a3 = (ArraySubListPtr)
			calloc( sizeof(ArraySubList), 1 );
		a3->expPairList = a0;
		a3->arraySubList = (ArraySubListPtr) t->arraySubList;
		t->arraySubList = (Ptr) a3;
	}

	return( NULL );
}
			
/*----------------------------------------------------------------*/

FUN void TermMarkSubstTermList( sl, i )
AssignListPtr sl; int i;
{
	if ( sl == NULL ) return;

	if (i) sl->assign->termRight->type += 10;
	else sl->assign->termRight->type -= 10;
	TermMarkSubstTermList( sl->assignList );
}

FUN TermPtr TermUnmarkf( t, p )
TermPtr t; Ptr p;
{
	if (t->type > 10) { 
		t->type -= 10;
		return( t );
	} else return( NULL );
}

FUN TermPtr TermSubstSim( t, sl )
TermPtr t; AssignListPtr sl;
{
/*	TermMarkSubstTermList( sl, 1 );		/* 1=mark*/
	t = TermFunction( t, sl, TermSubstListf );
/*	TermMarkSubstTermList( sl, 0 );		/* 0=unmark*/
	
	return( TermFunction( t, sl, TermUnmarkf ));
}

/*----------------------------------------------------------------*/

FUN int VarEqual( t1, t2 )
TermPtr t1, t2;
{
	if (t1->type != VAR ) return( 0 );
	if (t2->type != VAR ) return( 0 );
	if (strcmp( t1->name, t2->name )!=0) return( 0 );
	return( 1 );
}

FUN int TermEqual( t1, t2 )
TermPtr t1, t2;
{
	TermListPtr t5, t6;

	if (t1==t2) return( 1 );
	if (t1==NULL || t2==NULL) return( 0 );
	if (t1->type!=t2->type) return( 0 );
	if (t1->type == VAR ) {
		if (strcmp( t1->name, t2->name )!=0) return( 0 );
		else return( 1 );
	}
	if (t1->type == FUNC ) {
		if (strcmp( t1->name, t2->name )!=0) return( 0 );
		t5 = (TermListPtr) t1->termList;
		t6 = (TermListPtr) t2->termList;
		while( t5 != NULL && t6 !=NULL ){
			if (!TermEqual( t5->term, t6->term )) return( 0);
			t5 = (TermListPtr) t5->termList;
			t6 = (TermListPtr) t6->termList;
		}
		return( 1 );
	} else if (t1->type == ARR ) { 
		char l1[ MOLINE ], l2[ MOLINE ];
		TermPrint( t1, l1 );
		TermPrint( t2, l2 );
		return( strcmp( l1, l2 )==0 );
	}

	return( 0 ); 
}

/*----------------------------------------------------------------*/


FUN TermPtr TermFunction( t, s, f )
TermPtr t; AssignListPtr s; 
Ptr (*f)();
{
	Ptr p;

	if (t==NULL) return( t );

	p = f( t, s );

	if (p!=NULL) return( (TermPtr) p ); 

	switch (t->type) {
		case ARR:
			TermFunctionArraySubList( t->arraySubList, s, f );
		case FUNC:
			TermFunctionTermList( t->termList, s, f );
		case VAR: 
			break;
	}
	return( t );
}

FUN TermFunctionArraySubList( a, s, f )
ArraySubListPtr a; AssignListPtr s;
Ptr (*f)();
{
	if ( a == NULL ) return( NULL );

	TermFunctionExpPairList( a->expPairList, s, f );
	TermFunctionArraySubList( a->arraySubList, s, f );
}

FUN TermFunctionExpPairList( a, s, f )
ExpPairListPtr a; AssignListPtr s;
Ptr (*f)();
{
	if ( a == NULL ) return( NULL );

	TermFunctionExpPair( a->expPair, s, f );
	TermFunctionExpPairList( a->expPairList, s, f );
}

FUN TermFunctionExpPair( a, s, f )
ExpPairPtr a; AssignListPtr s;
Ptr (*f)();
{
	TermFunctionTermList( a->subList, s, f );
	a->exp = TermFunction( a->exp, s, f );
}

FUN TermFunctionTermList( a, s, f )
TermListPtr a; AssignListPtr s;
Ptr (*f)();
{
	if (a == NULL) return;

	a->term = TermFunction( a->term, s, f );
	TermFunctionTermList( a->termList, s, f );
}
