#include "sentence.h"

static FILE *vLog;
static int debug=0;

FUN int LogFileOpen()
{
	debug=1;
        vLog = fopen( "vLog", "w" );
}

FUN int Log( s1, f )
char *s1; int (*f)();
{
	if (debug==0) return;
	fprintf( vLog, "----- %s -----\n\n", s1 );
	f( sss );
	fprintf( vLog, "%s\n", sss );

	fclose( vLog );
        vLog = fopen( "vLog", "a" );
}

/*------------------------------------------------------------*/

FUN int ProcedurePrintDebug( p, ss )
ProcedurePtr p;
char *ss;
{
        char s1[ MOPROG ];
	ParamTrippleListPtr q;

	currentProcedure = p;

	*ss = 0;
        FormulaPrint( p->preCond, s1 );
        sprintf( ss+strlen(ss), "{ %s }\n", s1 );

        sprintf( s1, "%s %s(", "%PROC", p->name );
        strcat( ss, s1 );

	q = p->params;
 
/*
	while( q->paramTrippleList != NULL ) {
*/
	while( q != NULL ) {
		if (q->paramTrippleList==NULL ) break;
                sprintf( s1, "%s/%s:%s;", q->io, q->name, q->type );
                strcat( ss, s1 );
		q = q->paramTrippleList;
        }
 
/*
	if ( q->paramTrippleList != NULL ) {
*/
	if ( q != NULL ) {
                sprintf( s1, "%s/%s:%s", q->io, q->name, q->type );
                strcat( ss, s1 );
        }
 
        sprintf( s1, ")==\n" );
        strcat( ss, s1 );

        if ( p->loc != NULL && *(p->loc) != 0 ) {
                sprintf( s1, "%s %s\n", "%LOC", p->loc );
                strcat( ss, s1 );
        }
 
 
        sprintf( s1, "%s", "%STM [ \n" );
        strcat( ss, s1 );
 
        SentencePrintDebug( p->body, ss+strlen(ss), IND );
        sprintf( ss + strlen(ss), "]\n" );

        FormulaPrint( p->postCond, s1 );
        sprintf( ss+strlen(ss), "{ %s }\n", s1 );

}
 
FUN int ProcedureListPrintDebug( ss )
char *ss;
{
	ProcedureListPtr pl = &procedureList;

	while( pl->procedureList != NULL ) {
		ProcedurePrintDebug( pl->procedure, ss );
		strcat( ss, "\n" );
		ss += strlen( ss );
		pl = pl->procedureList;
        }
}

/*--------------------------*/


FUN SentencePrintDebug( l, s, k )
char *l; char *s;
{
	*s = 0;
	if (l==NULL || *l==0) return;
	SentencePrintPtrDebug( Sentence2Ptr( l ), s, k );
}

FUN SentencePrintPtrDebug( p, s, k )
SentencePtr p;
char *s;
int k;
{
	char s0[ MOLABEL ];
	char s1[ MOLABEL ];
	char s2[ MOLABEL ];
	char s3[ MOLABEL ];
	char t1[ MOPROG ];
	char t2[ MOPROG ];
	char *ss;

	if (p==NULL) return;


	ss = s;
	if (p->type!=SEQ) ss += PrintPreCond( p, ss, k );

	if (p->type!=SEQ) Blanks( k, ss );
	ss = ss+strlen( ss );

	switch (p->type) {
		case SEQ:
			SentencePrintDebug( p->labels1, t1, k );
			SentencePrintDebug( p->labels2, t2, k );
			sprintf( ss, "%s%s", t1, t2 );
			break;
		case COND:
			DivideLabels( p->labels, s0, s2 );
			DivideLabels( p->labels1, s1, s2 );
			DivideLabels( p->labels2, s3, s2 );
			FormulaPrint( p->cond, t1 );
			sprintf( ss, "?[LB=%s^%s", s0, t1 );
			ss += strlen( ss );
			SentencePrintDebug( p->labels1, t1, k+2 );
			SentencePrintDebug( p->labels2, t2, k+2 );
			sprintf( ss, "=>$OLB=%s|~=>$OLB=%s;\n%s%s", 
				s1, s3, t1, t2 );
			Blanks( k, ss + strlen( ss ));
			ss += strlen( ss );
			sprintf( ss, " ]\n" );
			break;
		case ELEM:
        		DivideLabels( p->labels, s1, s2 );
        		sprintf(ss, "LB=%s=>", s1 );
        		ss += strlen( ss );
        		AssignListPrint( p->assignList, ss );
        		ss += strlen( ss );
        		sprintf(ss, "^$OLB=%s;\n", s2 );
			break;
		case LOOP:
			DivideLabels( p->labels, s1, s2 );
			DivideLabels( p->labels1, s3, s1 );
			FormulaPrint( p->cond, t1 );
			sprintf( ss, "*[LB=%s^%s", s1,t1 );
			ss += strlen( ss );
			SentencePrintDebug( p->labels1, t1, k+2 );
			sprintf( ss, "=>($OLB=%s|$OLB=%s)\n%s", s3, s2, t1 );
			ss += strlen( ss ); 
			FormulaPrint( GetPostCond( p->labels1 ), t1 );
			Blanks( k+2, ss + strlen( ss ));
			ss += strlen( ss );
			sprintf( ss, "{%s}\n", t1 );
			Blanks( k, ss + strlen( ss ));
			ss += strlen( ss );
			sprintf( ss, " ]\n", t1 );
			break;
		case CALL:
			DivideLabels( p->labels, s1, s2 );
        		sprintf(ss, "LB=%s=>%s(", s1, p->labels1 );
        		ss += strlen( ss );
			SentCallParamPrint( p->labels1, p->assignList, ss );
        		ss += strlen( ss );
        		sprintf(ss, ")^$OLB=%s;\n", s2 );
			break;
	}
}
			
FUN int PrintPreCond( p, ss, k )
SentencePtr p;
int k;
char *ss;
{
	char *s = ss;
	char t1[ MOPROG ];

	Blanks( k, ss );
	FormulaPrint( p->preCond, t1 );
	sprintf( ss+strlen(ss), "{%s}\n", t1 );

	return( strlen( s ) );
}
