#include <stdio.h>
#include "proof.h"
#include <sys/types.h>
#include <sys/stat.h>

ProcedureList procedureList;
ProcedureListPtr currentProcedureList = &procedureList;
AssumptionList assumptionList;
ProcedurePtr currentProcedure;
SentenceListPtr sp;

/*------------------------------------------------*/

FUN int  CompressString( l )
char *l;
{
        char *l1;

        l1=l;

        while( *l ) if (isBlank(*l)) l++; else *l1++ = *l++;
        *l1 = 0;
}

FUN char *FileRead( fname )
char *fname;
{
	FILE *f;
	long size1;
	struct stat buf;
	char *l;
	char s[ MOLINE ];

	stat( fname, &buf );
	size1 = buf.st_size+1;

	l = (char*) calloc( size1, 1 );

	f = fopen( fname, "r" );

	while (1) {
		fgets( s, MOLINE, f );
		if ( feof(f) ) break;
	
		if (*s==';' && *(s+1)==';') ; else
		strcat( l, s );
	}

	CompressString( l );

	fclose( f );
	return( l );
}

/*----------------------------------------------------*/

extern Ptr SimplifySequentUseRewrite();
 
FUN int AssumptionList2SequentList()
{
	AssumptionListPtr b;
	AssumptionPtr a; 
	SequentListPtr p;
	FormulaPtr f1, f2;

	b = &assumptionList;
       	p = &sequentList;
	while (b!=NULL) {
		a = b->assumption;
		if (a==NULL) {
			b = b->assumptionList;
			continue;
		}

		f1 = (FormulaPtr) SimplifySequentUseRewrite( FormulaCopy( a->formula1 ));
		f2 = (FormulaPtr) SimplifySequentUseRewrite( FormulaCopy( a->formula2 ));

        	p->sequent = (SequentPtr) calloc( sizeof( Sequent ), 1 );
        	p->sequent->formulaList1 = Formula2FormulaList( f1, LAND );
        	p->sequent->formulaList2 = Formula2FormulaList( f2, LOR );
		strcpy( p->sequent->remark, a->procName );

        	p->sequentList = 
			(SequentListPtr) calloc( sizeof(SequentList), 1 );
        	p = p->sequentList;
		b = b->assumptionList;
	}
	sequentListPtr = p;
}

/*--------------------------------------------------*/

FUN int SequentListPrint( ss )
char *ss;
{
        ProcedureListPtr pl = &procedureList;

        while( pl->procedureList != NULL ) {
                sprintf( ss, "...%s...\n\n", pl->procedure->name );
                SequentPrint( pl->procedure->name, ss+strlen(ss) );
                strcat( ss, "\n" );
                ss += strlen( ss );
                pl = pl->procedureList;
        }         
}


/*--------------------------------------------------*/

int ProcedureListPrintDebug();

StartProg1( s0 )
char *s0;
{
	char *l;

	InitializeNewName();

	if (*s0!='{' && *s0!='%') l = FileRead( s0 );
	else l=s0;

	ProcedureReadList( l );
	Log( "Prog", ProcedureListPrint ); 
}

StartProg0()
{
	GenerateVerificationCond();
	Log( "Pre-Post-Conditions", ProcedureListPrintDebug );
	Log( "Verification Conditions", AssumptionListPrint ); 

        AssumptionList2SequentList( &assumptionList );
	Log( "Init Sequents", SequentListPrint ); 

        SimplifySequentAll();
	Log( "Last Sequents", SequentListPrint ); 
}
