#include "g.h"

extern void DivideLabels();

FUN int wSentenceRead( s, l )
char* s;
char *l;
{
	char l1[ MOLABEL ];
	char l2[ MOLABEL ];
	char l3[ MOLABEL ];
	int first = 1;

	*l = 0;
	if ( *s == '[' ) { s++; }
	while (*s ) {
		if ( *s == ']' ) break;
		if ( isLoop( s ) ) s += wSentLoopRead( s, l );
		else if ( isCase( s ) ) s += wSentCaseRead( s, l );
		else if ( isElem( s ) ) s += wSentElemRead( s, l );
		else if ( isCall( s ) ) s += wSentCallRead( s, l );
		else if ( isInv( s ) ) {
        		while (*s && *s!='}') s++; 
			s++;
			continue;
		} 
		else { Error( "sentenceRead" ); break; }
		if (first) {
			strcpy( l3, l );
			DivideLabels( l, l1, l2 );
			first = 0;
		} else { 
			wSentSeqComposition( l3, l );
			strcpy( l3, l );
		}
	}
}

/*---------------------------------------------------------------------*/

FUN int wSentLoopRead( s, l )
char *s;
char *l;
{
	int i, j, k;

	i = 2; j = 1;
	while( s[ i ] && j ) {
		if ( s[ i ] == '[' ) j++;
		if ( s[ i ] == ']' ) j--;
		i++;
	}

	s += 2;
        k = 0;
        while (!( s[ k ] == '=' && s[ k+1 ] == '>' )) k++;
        while( s[ k++ ] != '(' );

        j=1;
        while( s[ k ] && j ) {
                if ( s[ k ] == '(' ) j++;
                if ( s[ k ] == ')' ) j--;
                k++;
        }

        SentenceRead( s+k, l );

	wSentLoopRead1( s, l );

	return( i );
}

FUN int wSentLoopRead1( s, l )
char *s; char *l;
{
	char l1[ MOLABEL ];
	char l2[ MOLABEL ];
	char l3[ MOLABEL ];

	if ( isLB( s ) ) s += LabelRead( s, l1 );
	if ( *s == '^' ) s += 1 + wSentCondRead( s+1 );
      	if ( *s == '(' ) s += 1;
	if ( isNEXT( s ) ) s += 2;
	if ( isLB( s ) ) s += LabelRead( s, l2 );
	if ( *s == '|' ) s += 1;
	if ( isNEXT( s ) ) s += 2;
	if ( isLB( s ) ) s += LabelRead( s, l3 );
	if ( *s == ')' ) s += 1;

	sprintf( l, "(%s,%s)", l1, l3 );
}

FUN int wSentCondRead( s )
char *s;
{
	int i=0;

	while( !(s[i]=='=' && s[i+1]=='>') && s[i] ) i++;
	s[ i ] = 0;
	s[ i+1 ] = 0;

	return( i+2 );
}

/*------------------------------------------------------------------*/


FUN int wSentCaseRead( s, l )
char *s;
char *l;
{
        int i, j;
 
 
        i = 2; j = 1;
        while( s[ i ] && j ) {
                if ( s[ i ] == '[' ) j++;
                if ( s[ i ] == ']' ) j--;
                i++;
        }
 
        s += 2;
        j = 0;
        while( s[ j++ ] != ';' );
 
        wSentenceRead( s+j, l );

        wSentCaseRead1( s, l );

        return( i );
}
 
FUN int wSentCaseRead1( s, l )
char *s; char *l;
{
        char l1[ MOLABEL ];
        char l2[ MOLABEL ];
        char l3[ MOLABEL ];
        char l4[ MOLABEL ];
        char l5[ MOLABEL ];
 
        if ( isLB( s ) ) s += LabelRead( s, l1 );
        if ( *s == '^' ) s += 1 + wSentCondRead( s+1 );
        if ( isNEXT( s ) ) s += 2;
        if ( isLB( s ) ) s += LabelRead( s, l2 );
        if ( *s == '|' ) s += 1;
      	if ( *s == '~' ) s += 1;
        if ( isIMP( s ) ) s += 2;
        if ( isNEXT( s ) ) s += 2;
        if ( isLB( s ) ) s += LabelRead( s, l3 );
        if ( *s == ';' ) s += 1;
 
        DivideLabels( l, l4, l5 );
        sprintf( l, "(%s,%s)", l1, l5 );
}

FUN int wSentElemRead( s1, s2 )
char *s1, *s2;
{
	int i=0;

	while( !(s1[i]==';' ) && s1[i] ) i++;
	s1[ i ] = 0;

	wReadLabels( s1, s2 );

	return( i+1 );
}

FUN int wReadLabels( s, s2 )
char* s;
char* s2;
{
	char l1[ MOLABEL ];
	char l2[ MOLABEL ];

	if ( isLB( s ) ) s += LabelRead( s, l1 );
	while( *s && !(isNEXT( s ) && isLB( s+2 )) ) s++;
	s += 2;
	if ( isLB( s ) ) s += LabelRead( s, l2 );
        sprintf( s2, "(%s,%s)", l1, l2 );
	return( 0 );
}

/*---------------------------------------------------------------------*/

FUN int wSentSeqComposition( s1, s2 )
char *s1, *s2;
{
        char t1[ MOLABEL ];
        char t2[ MOLABEL ];
        char t3[ MOLABEL ];
        char t4[ MOLABEL ];

        DivideLabels( s1, t1, t4 );
        DivideLabels( s2, t3, t2 );
        if (strcmp( t3,t4)) {
		Error( "sent.seq" );
		return( 0 );
	}

        sprintf( s2, "(%s,%s)", t1, t2 );

        return( 1 );
}

/*--------------------------------------------------------------*/

FUN int wSentCallRead( s1, s2 )
char *s1, *s2;
{
	int i=0;
	int j = 0;

	while( s1[i] && ( s1[i]!=';' || j!=0 )) {
		if ( s1[i] == '(' ) j++;
		else if ( s1[i] == ')' ) j--;
		i++;
	}

	s1[ i ] = 0;


        wReadLabels( s1, s2 );

        return( i+1 );
}


