#include "proof.h"

void wClear( w, client_data, call_data )
Ptr w;
Ptr client_data, call_data;
{
/* should free memory... */
	assumptionList.assumption = NULL;
	assumptionList.assumptionList = NULL;
	procedureList.procedure = NULL;
	procedureList.procedureList = NULL;
	currentProcedureList = &procedureList;
	wRedisplay( w, client_data, call_data );
	wStart( w, client_data, call_data );
}

/*--------------------------------------------------------------*/

FUN int wFileWrite( s )
char *s;
{
	FILE *f;

        f = fopen( s, "w" );
	ProcedureListPrint( sss );
	fprintf( f, "Procedures:\n\n%s", sss );
	SequentListPrint( sss );
	fprintf( f, ";;--------------------------------------\n\n" );
	fprintf( f, "Remaining Verification Conditions:\n\n" );
	fprintf( f, "%s", sss );
	fclose( f );
}

FUN char *wCompressString( l )
char *l;
{
	CompressString( l );
	return( l );
}


/*--------------------------------------------------------------*/

FUN char *wGetProcList()
{
 
        ProcedureListPtr pl = &procedureList;
 
	*sss = 0;
        while( pl->procedureList != NULL ) {
                sprintf( sss+strlen(sss), "%s\n", pl->procedure->name );
                pl = pl->procedureList;
        }

	return( sss );
}
 
 
FUN char *wGetAssumptionList2( s )
char *s;
{
 
	*sss=0;
	if (s==NULL || *s==0) SequentListPrint( sss );
	else SequentPrint( s, sss );

	return( sss );
}

FUN char *wGetAssumptionList( s )
char *s;
{
 
	*sss=0;
	if (s==NULL || *s==0) AssumptionListPrint( sss );
	else AssumptionPrint( s, sss );

	return( sss );
}

FUN char *wGetProcPrePostCond( s )
char *s;
{
	ProcedurePtr p;
	char s0[ MOPROG ];
	char s1[ MOPROG ];

 	*sss=0;
	p = Procedure2Ptr( s );
	if (p==NULL) { return( NULL ); }

	sprintf( sss, "Pre-Condition: \n\n" );
	FormulaPrint( p->preCond, s0 );
	NiceFormula( s0, s1, 40 );
	sprintf( sss+strlen(sss), "%s", s1 );
	
	sprintf( sss+strlen(sss), "\nPost-Condition: \n\n" );
	FormulaPrint( p->postCond, s0 );
	NiceFormula( s0, s1, 40 );
	sprintf( sss+strlen(sss), "%s", s1 );
	
	return( sss );
}

FUN char *wGetSentPrePostCond( s )
char *s; 
{
        SentencePtr p;
        char s0[ MOPROG ];
        char s1[ MOPROG ];
 
	*sss = 0;
        p = Sentence2Ptr( s );  
        if (p==NULL) { return( NULL ); } 
 
        sprintf( sss, "Pre-Condition: \n\n" );
        FormulaPrint( p->preCond, s0 ); 
        NiceFormula( s0, s1, 40 );
        sprintf( sss+strlen(sss), "%s", s1 );
         
        sprintf( sss+strlen(sss), "\nPost-Condition: \n\n" );
        FormulaPrint( p->postCond, s0 );
        NiceFormula( s0, s1, 40 );
        sprintf( sss+strlen(sss), "%s", s1 );
         
        return( sss );
}


FUN char *wGetSentenceList( s1 )
char *s1;
{
	SentenceListPtr sl;

	currentProcedure = Procedure2Ptr( s1 );
	*sss = 0;
	sl = currentProcedure->sentenceList;
	while (sl!=NULL) {
		if ( sl->sentence != NULL )
		sprintf( sss+strlen(sss), "%s\n", sl->sentence->labels );
		sl = sl->sentenceList;
	}
	return( sss );
}

FUN char *wGetProcContent( s1 )
char *s1;
{
	currentProcedure = Procedure2Ptr( s1 );
	ProcedurePrint( currentProcedure, sss );
	return( sss );
}

FUN char *wGetSentenceContent( s )
char *s;
{
	char s0[ MOLINE ], s1[ MOLINE ];
	SentencePtr p;

        p = Sentence2Ptr( s );  
        if (p==NULL) { return( NULL ); } 
 
        FormulaPrint( p->preCond, s0 ); 
        NiceFormula( s0, s1, 40 );
        sprintf( sss, "{ %s }\n\n", s1 );

	SentencePrint( s, sss+strlen(sss), 0 );

        FormulaPrint( p->postCond, s0 );
        NiceFormula( s0, s1, 40 );
        sprintf( sss+strlen(sss), "\n{ %s }\n", s1 );

	return( sss );
}


FUN int NiceFormula( s, s1, n )
int n;
char *s, *s1;
{
	int ps=0;
	int i;
	char l1[ MOLINE ];
	char l2[ MOLINE ];

	s += GetLine( l1, &ps, s );
	while( 1 ) {
		s += GetLine( l2, &ps, s );
	
		while( strlen(l1)+strlen(l2) < n ) {
			strcpy( l1+strlen(l1), l2 );
			s += GetLine( l2, &ps, s );
			if (*l2==0) break;
		}
	
		strcpy( s1, l1 );
		s1 += strlen( s1 );
		if (*l2==0) break;
		strcpy( l1, l2 );
		*s1++ = '\n';
		i = ps;
		while (i--) *s1++ = ' ';
	}
	*s1 = 0;
}

FUN int GetLine( l1, ps, s )
int *ps; 
char *l1, *s;
{
	int i=0;

	*l1=0;
	if (*s==0) return( 0 );

	while (*s) {
		i++;
		if (*s=='(' || *s=='[') (*ps)++;
		else if (*s==']' || *s==')') (*ps)--;
		if ( isCon( *s )) break;
		*l1++ = *s++;
	}
	*l1++ = *s++;
	*l1 = 0;
	return( i );
}

