#include "proof.h"

/*------------------------------------------------------------*/

FUN int ProcedurePrint2( p, ss )
ProcedurePtr p;
char *ss;
{
        char s1[ MOPROG ];
	ParamTrippleListPtr q;

	*ss = 0;
        FormulaPrint( p->preCond, s1 );
        sprintf( ss+strlen(ss), "{ %s }\n", s1 );

        sprintf( s1, "%s %s(", "%PROC", p->name );
        strcat( ss, s1 );

	q = p->params;
 
/*
	while( q->paramTrippleList != NULL ) {
*/
	while( q != NULL ) {
		if (q->paramTrippleList==NULL ) break;
                sprintf( s1, "%s/%s:%s;", q->io, q->name, q->type );
                strcat( ss, s1 );
		q = q->paramTrippleList;
        }
 
/*
	if ( q->paramTrippleList != NULL ) {
*/
	if ( q != NULL ) {
                sprintf( s1, "%s/%s:%s", q->io, q->name, q->type );
                strcat( ss, s1 );
        }
 
        sprintf( s1, ")==\n" );
        strcat( ss, s1 );

        if ( p->loc != NULL && *(p->loc) != 0 ) {
                sprintf( s1, "%s %s\n", "%LOC", p->loc );
                strcat( ss, s1 );
        }
 
 
        sprintf( ss+strlen(ss), "%s[ \n	%s \n]\n", "%STM", p->body );
 
        FormulaPrint( p->postCond, s1 );
        sprintf( ss+strlen(ss), "{ %s }\n", s1 );

}

extern SentencePtr Sentence2Ptr();
extern void DivideLabels();
extern FormulaPtr GetPostCond();

/*---------------------------------------------------------------------*/

FUN SentencePrint2( l, s, k )
char *l;
char *s;
int k;
{
	char s0[ MOLABEL ];
	char s1[ MOLABEL ];
	char s2[ MOLABEL ];
	char s3[ MOLABEL ];
	char t1[ MOPROG ];
	char t2[ MOPROG ];
	char *ss;
	SentencePtr p = Sentence2Ptr( l );

	if (p==NULL) return;

	if (p->type!=SEQ) Blanks( k, s );
	ss = s+strlen( s );

	switch (p->type) {
		case SEQ:
			sprintf( ss, "   %s;\n   %s;\n", 
				p->labels1, p->labels2 );
			break;
		case COND:
			DivideLabels( p->labels, s0, s2 );
			DivideLabels( p->labels1, s1, s2 );
			DivideLabels( p->labels2, s3, s2 );
			FormulaPrint( p->cond, t1 );
			sprintf( ss, "   ?[LB=%s^%s", s0, t1 );
			ss += strlen( ss );
			sprintf( ss, "=>$OLB=%s|~=>$OLB=%s;\n      %s;\n      %s\n",
				s1, s3, p->labels1, p->labels2 );
			Blanks( k, ss + strlen( ss ));
			ss += strlen( ss );
			sprintf( ss, "   ]\n" );
			break;
		case ELEM:
        		DivideLabels( p->labels, s1, s2 );
        		sprintf(ss, "LB=%s=>", s1 );
        		ss += strlen( ss );
        		AssignListPrint( p->assignList, ss );
        		ss += strlen( ss );
        		sprintf(ss, "^$OLB=%s;\n", s2 );
			break;
		case LOOP:
			DivideLabels( p->labels, s1, s2 );
			DivideLabels( p->labels1, s3, s1 );
			FormulaPrint( p->cond, t1 );
			sprintf( ss, "   *[LB=%s^%s", s1,t1 );
			ss += strlen( ss );
			sprintf( ss, "=>($OLB=%s|$OLB=%s)\n      %s;\n", 
				s3, s2, p->labels1 );
			ss += strlen( ss ); 
/*
			FormulaPrint( GetPostCond( p->labels1 ), t1 );
			Blanks( k+2, ss + strlen( ss ));
			ss += strlen( ss );
			sprintf( ss, "{%s}\n", t1 );
			Blanks( k, ss + strlen( ss ));
			ss += strlen( ss );
*/
			sprintf( ss, "   ]\n", t1 );
			break;
		case CALL:
			DivideLabels( p->labels, s1, s2 );
        		sprintf(ss, "LB=%s=>%s(", s1, p->labels1 );
        		ss += strlen( ss );
			SentCallParamPrint( p->labels1, p->assignList, ss );
        		ss += strlen( ss );
        		sprintf(ss, ")^$OLB=%s;\n", s2 );
			break;
	}
}

/*--------------------------------------*/

FUN wSentenceRead2( s, s1 )
char *s1;
char *s;
{
	while (*s && (*s != '(') ) s++;
	while (*s && (*s != ')') ) *s1++ = *s++;
	*s1++ = *s++;
	*s1 = 0;
}

/*--------------------------------------*/

int n;
char sName[ MOLABEL ][ 1000 ];


FUN char *wGetSentenceContent2( s )
char *s;
{
	char s0[ MOLINE ], s1[ MOLINE ];
	SentencePtr p;

	if (*s==0) {
		n--;
		if (n<=0) return( NULL );
		strcpy( s, sName[ n-1 ] );
	} else {
		strcpy( sName[ n++ ], s );
	}
        p = Sentence2Ptr( s );  
        if (p==NULL) { return( NULL ); } 
 
        FormulaPrint( p->preCond, s0 ); 
        NiceFormula( s0, s1, 40 );
        sprintf( sss, "{ %s }\n\n", s1 );

	SentencePrint2( s, sss+strlen(sss), 0 );

        FormulaPrint( p->postCond, s0 );
        NiceFormula( s0, s1, 40 );
        sprintf( sss+strlen(sss), "\n{ %s }\n", s1 );

	return( sss );
}

FUN char *wGetProcContent2( s1 )
char *s1;
{
	currentProcedure = Procedure2Ptr( s1 );
	ProcedurePrint2( currentProcedure, sss );
	return( sss );
}

FUN wPostCleanStack()
{
	n=0;
}
